import javafx.application.*;
import javafx.scene.*;
import javafx.scene.layout.*;
import javafx.scene.control.*;
import javafx.scene.paint.*;
import javafx.scene.image.*;
import javafx.scene.effect.*;
import javafx.scene.text.*;
import javafx.scene.input.*;
import javafx.scene.canvas.*;
import javafx.scene.shape.*;
import javafx.stage.*;
import javafx.event.*;
import javafx.geometry.*;
import javafx.collections.*;

public class hanoi extends Application
{   

    private int [] dodai1 = {1,2,3,4,5,0};
    private int [] dodai2 = {0,0,0,0,0,0};
    private int [] dodai3 = {0,0,0,0,0,0};

    private Canvas cv;
    private Label lb;
    private int sum = 0;
    private boolean plate;
    private Image img;
    private Stage stage1;
    private Stage stage2;
    private Stage stage3;

    public void start(Stage stage) throws Exception
    {   
        cv = new Canvas(1100,400);
        GraphicsContext gc = cv.getGraphicsContext2D();

        MenuBar mb = new MenuBar();
        mb.setBackground(new Background(new BackgroundFill(Color.LIGHTGREEN,null,null)));
        Menu m = new Menu("[");
        MenuItem mi1 = new MenuItem("nmC̓Ƃ́H");
        ObservableList<Menu> lstm = mb.getMenus();
        lstm.add(m);
        ObservableList<MenuItem> lstmi = m.getItems();
        lstmi.add(mi1);
        MyMenuHandler menuhandler = new MyMenuHandler();
        m.addEventHandler(ActionEvent.ANY, menuhandler);


        lb = new Label("i͂Tił");
        Font ft1 = new Font(15);
        Image [] num = new Image[3];
        num[0] = new Image("1.jpg");
        num[1] = new Image("2.jpg");
        num[2] = new Image("3.jpg");
        lb.setFont(ft1);
        gc.setFill(Color.BROWN);
        gc.fillRect(50.0, 350.0, 300.0, 50.0);
        gc.setFill(Color.BROWN);
        gc.fillRect(400.0, 350.0, 300.0, 50.0);
        gc.setFill(Color.BROWN);
        gc.fillRect(750.0, 350.0, 300.0, 50.0);
        gc.drawImage(num[0],175,350,50,50);
        gc.drawImage(num[1],525,350,50,50);
        gc.drawImage(num[2],875,350,50,50);
    
        drawCanvas();

        Button[] bt = new Button[6];
        bt[0] = new Button("QԖڂֈړ");
        bt[1] = new Button("RԖڂֈړ");
        bt[2] = new Button("PԖڂֈړ");
        bt[3] = new Button("RԖڂֈړ");
        bt[4] = new Button("PԖڂֈړ");
        bt[5] = new Button("QԖڂֈړ");
        bt[0].setId("B1to2");
        bt[1].setId("B1to3");
        bt[2].setId("B2to1");
        bt[3].setId("B2to3");
        bt[4].setId("B3to1");
        bt[5].setId("B3to2");

        MyEventHandler actionhandler = new MyEventHandler();
        bt[0].addEventHandler(ActionEvent.ANY, actionhandler);
        bt[1].addEventHandler(ActionEvent.ANY, actionhandler);
        bt[2].addEventHandler(ActionEvent.ANY, actionhandler);
        bt[3].addEventHandler(ActionEvent.ANY, actionhandler);
        bt[4].addEventHandler(ActionEvent.ANY, actionhandler);
        bt[5].addEventHandler(ActionEvent.ANY, actionhandler);

        GridPane gp2 = new GridPane();
        gp2.add(bt[0],0,0);
        gp2.add(bt[1],1,0);
        gp2.add(bt[2],2,0);
        gp2.add(bt[3],3,0);
        gp2.add(bt[4],4,0);
        gp2.add(bt[5],5,0);
        gp2.setHgap(90);
        gp2.setAlignment(Pos.CENTER);
        gp2.setPadding(new Insets(20));
        gp2.setBackground(new Background(new BackgroundFill(Color.LIMEGREEN,null,null)));

        BorderPane bp = new BorderPane();
        bp.setCenter(lb);
        bp.setPadding(new Insets(5));

        VBox vb = new VBox();
        ObservableList<Node> lst =vb.getChildren();
        lst.add(mb);
        lst.add(cv);
        lst.add(gp2);
        lst.add(bp);
        vb.setSpacing(10);
        vb.setBackground(null);

        Scene scene = new Scene(vb);
        scene.setFill(Color.WHITE);
        stage1 = new Stage();
        stage1.setScene(scene);
        stage1.setResizable(false);
        stage1.setTitle("nmC̓");

        stage1.show();

    }

    public void clear()
    {   
        Font ft2 = new Font("HGSoeiKakupoptai",30);
        Font ft3 = new Font(15);
        Label lb2 = new Label("clear!!");
        Label lb3 = new Label(sum+"ŃNAł܂");
        lb2.setTextFill(Color.RED);
        lb2.setFont(ft2);
        lb3.setFont(ft3);

        VBox vb2 = new VBox();
        vb2.setAlignment(Pos.CENTER);
        ObservableList<Node> lst2 = vb2.getChildren();
        lst2.add(lb2);
        lst2.add(lb3);
        vb2.setPadding(new Insets(10));
        vb2.setSpacing(15);

        Scene scene2 = new Scene(vb2);
        stage2 = new Stage();

        MyWindowHandler windowhandler = new MyWindowHandler();
        stage2.addEventHandler(WindowEvent.ANY, windowhandler);

        stage2.initOwner(stage1);
        stage2.setScene(scene2);
        stage2.setResizable(false);
        stage2.initModality(Modality.WINDOW_MODAL);

        stage2.show();
    }

    public void rulu()
    {   
        Font ft4 = new Font(13);
        Font ft5 = new Font(15);
        Label lb4 = new Label("nmC̓inmĈƂATower of Hanoij̓pŸB\no̓܂̓[JX^[(Lucas' Tower)ƂĂ΂");
        Label lb5 = new Label("ȉ̃[ɏ]ĂׂĂ̔E[̓yɈړ΃NA");
        lb5.setTextFill(Color.RED);
        Label lb6 = new Label("E3̓y(F)ƁA傫̈قȂ镡̔\");
        Label lb7 = new Label("Eŏׂ͂Ă̔[̓yɏ̂ɂȂ悤ɏɐςݏd˂Ă");
        Label lb8 = new Label("EɈꖇǂꂩ̓yɈړ邱Ƃł邪AȔ̏ɑ傫Ȕ悹邱Ƃ͂łȂ");

        lb4.setFont(ft4);
        lb5.setFont(ft5);
        lb6.setFont(ft5);
        lb7.setFont(ft5);
        lb8.setFont(ft5);

        VBox vb3 = new VBox();
        ObservableList<Node> lst3 = vb3.getChildren();
        lst3.add(lb4);
        lst3.add(lb5);
        lst3.add(lb6);
        lst3.add(lb7);
        lst3.add(lb8);

        vb3.setPadding(new Insets(10));
        vb3.setSpacing(10);

        Scene scene3 = new Scene(vb3);
        stage3 = new Stage();

        stage3.initOwner(stage1);
        stage3.setScene(scene3);
        stage3.initModality(Modality.WINDOW_MODAL);
        stage3.setResizable(false);
        stage3.setTitle("[");

        stage3.show();
    }

   

    private void moving(int a, int b){
        int pA;
        int pB;
        int tmp = 0;
        GraphicsContext gc3 = cv.getGraphicsContext2D();
        if(a==1&&b==2){
            pA = dodai1.length-2;
            pB = dodai2.length-2;
            int intMin = 6;
            for(int i=0;i<dodai1.length-1;i++){
                    if(dodai1[i]!=0&&intMin>dodai1[i]){
                        intMin = dodai1[i];
                        pA = i;
                    } 
            }
            intMin = 6;
            for(int i=0;i<dodai2.length-1;i++){
                if(intMin>=dodai2[i]){
                        intMin = dodai2[i];
                        pB = i;
                    }
            }

            if(dodai2[pB+1]==0||dodai1[pA]<dodai2[pB+1]){
                
                    switch(dodai1[pA]){
                        case 1:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(175,50*(pA+2), 250, 50);
                        gc3.setFill(Color.BLUE);
                        gc3.fillRect(525.0, 50*(pB+2), 50.0, 50.0);
                        break;
                        case 2:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(150,50*(pA+2), 250, 50);
                        gc3.setFill(Color.GREEN);
                        gc3.fillRect(500.0, 50*(pB+2), 100.0, 50.0);
                        break;
                        case 3:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(125,50*(pA+2), 250, 50);
                        gc3.setFill(Color.RED);
                        gc3.fillRect(475.0, 50*(pB+2), 150.0, 50.0);
                        break;
                        case 4:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(100,50*(pA+2), 250, 50);
                        gc3.setFill(Color.PURPLE);
                        gc3.fillRect(450.0, 50*(pB+2), 200.0, 50.0);
                        break;
                        case 5:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(75,50*(pA+2), 250, 50);
                        gc3.setFill(Color.YELLOW);
                        gc3.fillRect(425.0, 50*(pB+2), 250.0, 50.0);
                        break;
                    }
                    tmp = dodai1[pA];
                    dodai1[pA] = dodai2[pB];
                    dodai2[pB] = tmp;
                    sum++;
                    lb.setText(""+sum+"ڂł");
                
            }else{
                lb.setText("ړɈړ菬̂ňړł܂");
            }
        }else if(a==1&&b==3){
            pA = dodai1.length-2;
            pB = dodai3.length-2;
            int intMin = 6;
            for(int i=0;i<dodai1.length-1;i++){
                    if(dodai1[i]!=0&&intMin>dodai1[i]){
                        intMin = dodai1[i];
                        pA = i;
                    } 
            }
            intMin = 6;
            for(int i=0;i<dodai3.length-1;i++){
                if(intMin>=dodai3[i]){
                        intMin = dodai3[i];
                        pB = i;
                    }
            }

            if(dodai3[pB+1]==0||dodai1[pA]<dodai3[pB+1]){
                
                    switch(dodai1[pA]){
                        case 1:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(175,50*(pA+2), 250, 50.0);
                        gc3.setFill(Color.BLUE);
                        gc3.fillRect(875.0, 50*(pB+2), 50.0, 50.0);
                        break;
                        case 2:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(150,50*(pA+2), 250, 50);
                        gc3.setFill(Color.GREEN);
                        gc3.fillRect(850.0, 50*(pB+2), 100.0, 50.0);
                        break;
                        case 3:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(125,50*(pA+2), 250, 50);
                        gc3.setFill(Color.RED);
                        gc3.fillRect(825.0, 50*(pB+2), 150.0, 50.0);
                        break;
                        case 4:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(100,50*(pA+2), 250, 50);
                        gc3.setFill(Color.PURPLE);
                        gc3.fillRect(800.0, 50*(pB+2), 200.0, 50.0);
                        break;
                        case 5:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(75,50*(pA+2), 250, 50);
                        gc3.setFill(Color.YELLOW);
                        gc3.fillRect(775.0, 50*(pB+2), 250.0, 50.0);
                        break;
                    }
                    tmp = dodai1[pA];
                    dodai1[pA] = dodai3[pB];
                    dodai3[pB] = tmp;
                    sum++;
                    lb.setText(""+sum+"ڂł");
                
            }else{
                lb.setText("ړɈړ菬̂ňړł܂");
            }
        }else if(a==2&&b==1){
            pA = dodai2.length-2;
            pB = dodai1.length-2;
            int intMin = 6;
            for(int i=0;i<dodai2.length-1;i++){
                    if(dodai2[i]!=0&&intMin>dodai2[i]){
                        intMin = dodai2[i];
                        pA = i;
                    } 
            }
            intMin = 6;
            for(int i=0;i<dodai1.length-1;i++){
                if(intMin>=dodai1[i]){
                        intMin = dodai1[i];
                        pB = i;
                    }
            }

            if(dodai1[pB+1]==0||dodai2[pA]<dodai1[pB+1]){

                    switch(dodai2[pA]){
                        case 1:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(525.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.BLUE);
                        gc3.fillRect(175.0, 50*(pB+2), 50.0, 50.0);
                        break;
                        case 2:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(500.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.GREEN);
                        gc3.fillRect(150.0, 50*(pB+2), 100.0, 50.0);
                        break;
                        case 3:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(475.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.RED);
                        gc3.fillRect(125.0, 50*(pB+2), 150.0, 50.0);
                        break;
                        case 4:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(450.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.PURPLE);
                        gc3.fillRect(100.0, 50*(pB+2), 200.0, 50.0);
                        break;
                        case 5:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(425.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.YELLOW);
                        gc3.fillRect(75.0, 50*(pB+2), 250.0, 50.0);
                        break;
                    }
                    tmp = dodai2[pA];
                    dodai2[pA] = dodai1[pB];
                    dodai1[pB] = tmp;
                    sum++;
                    lb.setText(""+sum+"ڂł");
            }else{
                lb.setText("ړɈړ菬̂ňړł܂");
            }
                
        }else if(a==2&&b==3){
            pA = dodai2.length-2;
            pB = dodai3.length-2;
            int intMin = 6;
            for(int i=0;i<dodai2.length-1;i++){
                    if(dodai2[i]!=0&&intMin>dodai2[i]){
                        intMin = dodai2[i];
                        pA = i;
                    } 
            }
            intMin = 6;
            for(int i=0;i<dodai3.length-1;i++){
                if(intMin>=dodai3[i]){
                        intMin = dodai3[i];
                        pB = i;
                    }
            }

            if(dodai3[pB+1]==0||dodai2[pA]<dodai3[pB+1]){

                    switch(dodai2[pA]){
                        case 1:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(525.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.BLUE);
                        gc3.fillRect(875.0, 50*(pB+2), 50.0, 50.0);
                        break;
                        case 2:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(500.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.GREEN);
                        gc3.fillRect(850.0, 50*(pB+2), 100.0, 50.0);
                        break;
                        case 3:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(475.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.RED);
                        gc3.fillRect(825.0, 50*(pB+2), 150.0, 50.0);
                        break;
                        case 4:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(450.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.PURPLE);
                        gc3.fillRect(800.0, 50*(pB+2), 200.0, 50.0);
                        break;
                        case 5:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(425.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.YELLOW);
                        gc3.fillRect(775.0, 50*(pB+2), 250.0, 50.0);
                        break;
                    }
                    tmp = dodai2[pA];
                    dodai2[pA] = dodai3[pB];
                    dodai3[pB] = tmp;
                    sum++;
                    lb.setText(""+sum+"ڂł");
            }else{
                lb.setText("ړɈړ菬̂ňړł܂");
            }
        }else if(a==3&&b==1){
            pA = dodai3.length-2;
            pB = dodai1.length-2;
            int intMin = 6;
            for(int i=0;i<dodai3.length-1;i++){
                    if(dodai3[i]!=0&&intMin>dodai3[i]){
                        intMin = dodai3[i];
                        pA = i;
                    } 
            }
            intMin = 6;
            for(int i=0;i<dodai1.length-1;i++){
                if(intMin>=dodai1[i]){
                        intMin = dodai1[i];
                        pB = i;
                    }
            }

            if(dodai1[pB+1]==0||dodai3[pA]<dodai1[pB+1]){

                    switch(dodai3[pA]){
                        case 1:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(875.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.BLUE);
                        gc3.fillRect(175.0, 50*(pB+2), 50.0, 50.0);
                        break;
                        case 2:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(850.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.GREEN);
                        gc3.fillRect(150.0, 50*(pB+2), 100.0, 50.0);
                        break;
                        case 3:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(825.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.RED);
                        gc3.fillRect(125.0, 50*(pB+2), 150.0, 50.0);
                        break;
                        case 4:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(800.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.PURPLE);
                        gc3.fillRect(100.0, 50*(pB+2), 200.0, 50.0);
                        break;
                        case 5:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(775.0, 50*(pA+2), 250.0, 50.0);
                        gc3.setFill(Color.YELLOW);
                        gc3.fillRect(75.0, 50*(pB+2), 250.0, 50.0);
                        break;
                    }
                    tmp = dodai3[pA];
                    dodai3[pA] = dodai1[pB];
                    dodai1[pB] = tmp;
                    sum++;
                    lb.setText(""+sum+"ڂł");
            }else{
                lb.setText("ړɈړ菬̂ňړł܂");
            }
        }else if(a==3&&b==2){
            pA = dodai3.length-2;
            pB = dodai2.length-2;
            int intMin = 6;
            for(int i=0;i<dodai3.length-1;i++){
                    if(dodai3[i]!=0&&intMin>dodai3[i]){
                        intMin = dodai3[i];
                        pA = i;
                    } 
            }
            intMin = 6;
            for(int i=0;i<dodai2.length-1;i++){
                if(intMin>=dodai2[i]){
                        intMin = dodai2[i];
                        pB = i;
                    }
            }

            if(dodai2[pB+1]==0||dodai3[pA]<dodai2[pB+1]){
                
                    switch(dodai3[pA]){
                        case 1:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(875,50*(pA+2), 250, 50);
                        gc3.setFill(Color.BLUE);
                        gc3.fillRect(525.0, 50*(pB+2), 50.0, 50.0);
                        break;
                        case 2:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(850,50*(pA+2), 250, 50);
                        gc3.setFill(Color.GREEN);
                        gc3.fillRect(500.0, 50*(pB+2), 100.0, 50.0);
                        break;
                        case 3:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(825,50*(pA+2), 250, 50);
                        gc3.setFill(Color.RED);
                        gc3.fillRect(475.0, 50*(pB+2), 150.0, 50.0);
                        break;
                        case 4:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(800,50*(pA+2), 250, 50);
                        gc3.setFill(Color.PURPLE);
                        gc3.fillRect(450.0, 50*(pB+2), 200.0, 50.0);
                        break;
                        case 5:
                        gc3.setFill(Color.WHITE);
                        gc3.fillRect(775,50*(pA+2), 250, 50);
                        gc3.setFill(Color.YELLOW);
                        gc3.fillRect(425.0, 50*(pB+2), 250.0, 50.0);
                        break;
                    }
                    tmp = dodai3[pA];
                    dodai3[pA] = dodai2[pB];
                    dodai2[pB] = tmp;
                    sum++;
                    lb.setText(""+sum+"ڂł");
                
            }else{
                lb.setText("ړɈړ菬̂ňړł܂");
            }
        }
    }

    private void NoPlate(int a){
        switch(a){
            case 1:
            for(int i=0;i<dodai1.length-1;i++){
                if(dodai1[i]!=0){plate = true;}
                else{plate = false;}
            }
            break;
            case 2:
            for(int i=0;i<dodai2.length-1;i++){
                if(dodai2[i]!=0){plate = true;}
                else{plate = false;}
            }
            break;
            case 3:
            for(int i=0;i<dodai3.length-1;i++){
                if(dodai3[i]!=0){plate = true;}
                else{plate = false;}
            }
            break;
        }
    }

    public void drawCanvas()
    {
        GraphicsContext gc2 = cv.getGraphicsContext2D();
        
        gc2.setFill(Color.YELLOW);
        gc2.fillRect(75.0, 300.0, 250.0, 50.0);
        gc2.setFill(Color.PURPLE);
        gc2.fillRect(100.0, 250.0, 200.0, 50.0);
        gc2.setFill(Color.RED);
        gc2.fillRect(125.0, 200.0, 150.0, 50.0);
        gc2.setFill(Color.GREEN);
        gc2.fillRect(150.0, 150.0, 100.0, 50.0);
        gc2.setFill(Color.BLUE);
        gc2.fillRect(175.0, 100.0, 50.0, 50.0);
        
    }

    private class MyEventHandler implements EventHandler<ActionEvent>
    {   
        public void handle(ActionEvent e)
        {  
            GraphicsContext gc4 = cv.getGraphicsContext2D();
            Button bt = (Button)e.getTarget();
            String str = bt.getId();
            switch(str){
                case "B1to2":
                NoPlate(1);
                if(plate){
                    moving(1,2);
                }else{
                    lb.setText("ړł܂");
                }
                break;
                case "B1to3":
                NoPlate(1);
                if(plate){
                    moving(1,3);
                }else{
                    lb.setText("ړł܂");
                }
                break;
                case "B2to1":
                NoPlate(2);
                if(plate){
                    moving(2,1);
                }else{
                    lb.setText("ړł܂");
                }
                break;
                case "B2to3":
                NoPlate(2);
                if(plate){
                    moving(2,3);
                }else{
                    lb.setText("ړł܂");
                }
                break;
                case "B3to1":
                NoPlate(3);
                if(plate){
                    moving(3,1);
                }else{
                    lb.setText("ړł܂");
                }
                break;
                case "B3to2":
                NoPlate(3);
                if(plate){
                    moving(3,2);
                }else{
                    lb.setText("ړł܂");
                }
                break;
            }
            if(dodai3[0]==1&&dodai3[1]==2&&dodai3[2]==3&&dodai3[3]==4&&dodai3[4]==5){
                clear();
            }
        }
    }

    private class MyWindowHandler implements EventHandler<WindowEvent>
    {
        public void handle(WindowEvent w)
        {
            EventType<WindowEvent> type = w.getEventType();
            if(type == WindowEvent.WINDOW_CLOSE_REQUEST){
                System.exit(0);
            }

        }
    }

    private class MyMenuHandler implements EventHandler<ActionEvent>
    {
        public void handle(ActionEvent e)
        {
            rulu();
        }

    }

    public static void main(String[] args)
    {
        launch(args);
    }
}